package apoSkunkman.ai;

import apoSkunkman.entity.ApoSkunkmanGoodie;

/**
 * Klasse die ein Goodie im Levelarray reprsentiert und zurckgibt um welches Goodie es sich handelt<br />
 * und wie lange es noch sichtbar ist bevor es verschwindet<br />
 * @author Dirk Aporius
 *
 */
public class ApoSkunkmanAILevelGoodie extends ApoSkunkmanAILevelEntity {

	private final ApoSkunkmanGoodie goodie;
	
	public ApoSkunkmanAILevelGoodie(ApoSkunkmanGoodie entity) {
		super(entity);
		this.goodie = entity;
	}

	/**
	 * gibt das Goodie zurck<br />
	 * mgliche Konstanten sind:<br />
	 * ApoSkunkmanAIConstants.GOODIE_GOOD_WIDTH fr ein Goodie, das die Feuerrate um 1 erhht<br />
	 * ApoSkunkmanAIConstants.GOODIE_GOOD_SKUNKMAN fr ein Goodie, das die Anzahl der maximal legbaren Skunkmans um 1 erhht<br />
	 * ApoSkunkmanAIConstants.GOODIE_GOOD_FAST fr ein Goodie, das die Geschwindigkeit erhht<br />
	 * ApoSkunkmanAIConstants.GOODIE_GOOD_GOD fr ein Goodie, das alle Werte maximiert<br />
	 * ApoSkunkmanAIConstants.GOODIE_BAD_WIDTH fr ein Goodie, das die Feuerrate um 1 senkt<br />
	 * ApoSkunkmanAIConstants.GOODIE_BAD_SKUNKMAN fr ein Goodie, das die Anzahl der maximal legbaren Skunkmans um 1 senkt<br />
	 * ApoSkunkmanAIConstants.GOODIE_BAD_FAST fr ein Goodie, das die Geschwindigkeit senkt<br />
	 * ApoSkunkmanAIConstants.GOODIE_BAD_GOD fr ein Goodie, das alle Werte des Spieler minimiert<br />
	 * @return gibt das Goodie zurck
	 */
	public int getGoodie() {
		return this.goodie.getGoodie();
	}
	
	/**
	 * gibt die Zeit zurck, wielange das Goodie noch sichtbar ist in Millisekunden
	 * @return gibt die Zeit zurck, wielange das Goodie noch sichtbar ist in Millisekunden
	 */
	public int getTimeLeftVisible() {
		return this.goodie.getTimeLeftVisible();
	}
}
